<template>
  <div v-show="isLoading" class="flex h-20 items-center justify-center">
    <SLoadingSpinner class="h-20 w-20" />
  </div>
  <div v-show="!isLoading" class="flex flex-col gap-y-4">
    <div>
      <SSelect :value="selectedShapeKey" :options="options" label="Shape" @change="selectShape" />
    </div>
    <form
      v-if="selectedShape"
      action=""
      @submit="handleSearchSubmit"
      class="flex flex-col gap-y-4 pb-5"
    >
      <div>
        <ShapeForm
          :shapes-data="selectedShape"
          @form-data-changed="(formData: any) => (searchData = formData)"
        />
      </div>
      <div class="flex flex-row">
        <SButton
          icon="search"
          variant="primary"
          type="submit"
          :disabled="isSearchLoading || !searchData"
          @submit="handleSearchSubmit"
          >Search</SButton
        >
        <SLoadingSpinner v-if="isSearchLoading" class="ml-4" />
      </div>
    </form>
    <div v-if="shownSearchData">
      <SJsonPreview :content="shownSearchData" />
    </div>
  </div>
</template>

<script setup lang="ts">
import { ref, computed } from 'vue';
import type { ServiceShapesData } from '../../../types/shapes';
import ShapeForm from '../shapes/ShapeForm.vue';
import SSelect from '../common/SSelect.vue';
import SButton from '../common/SButton.vue';
import SLoadingSpinner from '../common/SLoadingSpinner.vue';
import SJsonPreview from '../common/SJsonPreview.vue';
import { getAllAvailableShapes } from '../../services/advancedSearch';

const isLoading = ref(false);
const isSearchLoading = ref(false);
const shapesData = ref<ServiceShapesData[]>([]);
const selectedShapeKey = ref<string | undefined>();
const searchData = ref<Record<string, Record<string, unknown>> | null>(null);
const shownSearchData = ref('');
const showSearchData = ref(false);

const selectShape = (key: string) => {
  selectedShapeKey.value = key;
  searchData.value = null;
  shownSearchData.value = '';
};

const selectedShape = computed(() => {
  return shapesData.value.find((shapeData) => shapeData.shapeFileName === selectedShapeKey.value);
});

const fetchShapesData = async () => {
  try {
    isLoading.value = true;
    shapesData.value = await getAllAvailableShapes();
    selectedShapeKey.value = shapesData.value[0].shapeFileName;
  } catch (error) {
    console.error(error);
  } finally {
    isLoading.value = false;
  }
};

fetchShapesData();

const options = computed(() =>
  shapesData.value.map((shapeData) => ({
    key: shapeData.shapeFileName,
    label: shapeData.shapeFileName,
  }))
);

const handleSearchSubmit = (e: Event) => {
  e.preventDefault();
  shownSearchData.value = JSON.stringify(searchData.value, null, 2);
  isSearchLoading.value = true;

  setTimeout(() => {
    showSearchData.value = true;
    isSearchLoading.value = false;
  }, 1000);
};
</script>
